<template>
    <div class="header-search__wrapper">
        <form :action="action" method="POST" autocomplete="off">
            <input
                type="text"
                name="search"
                placeholder="Поиск"
                v-model="search"
                @input="autocomplete"
                @focus="showAutocomplete = true"
                @blur="hideAutocomplete">
            <div class="autocomplete-container"
                v-show="showAutocomplete && autocompleteItems.length>0"
                v-if="autocompleteItems.length > 0">
                <a v-for="(item, index) in autocompleteItems" :key="index" :href="'/product/' + item.id" class="item">
                    <img :src="item.image" width="40" :alt="item.name">
                    {{item.name}}
                </a>
            </div>
            <input type="hidden" name="_token" :value="csrf">
            <button><i class="fas fa-search"></i></button>
        </form>
    </div>
</template>

<script>
    import axios from 'axios';

    export default {
        props: {
            action: {
                type: String,
                required: true
            },
            csrf: {
                type: String,
                required: true
            },
        },

        data() {
            return {
                search: '',
                showAutocomplete: false,
                autocompleteItems: []
            }
        },

        computed: {

        },

        methods: {
            autocomplete() {
                if (this.search.length > 2) {
                    axios.get('/product/autocomplete/' + this.search)
                        .then((response) => {
                            this.autocompleteItems = response.data;
                        });
                }
            },
            hideAutocomplete() {
                setTimeout(() => {this.showAutocomplete = false}, 100);
            }
        }
    };
</script>

<style lang="scss" scoped>
    @import "./resources/sass/vars";

    .autocomplete-container {
        z-index: 2;
        position: absolute;
        left: 0;
        top: 100%;
        width: calc(100% - 1px);
        border: 1px solid rgba($red, 0.4);
        background: $lightgray;
        border-radius: 0.3rem;

        .item {
            display: block;
            text-decoration: none;
            color: $black;
            padding: 0.5rem;

            &:hover {
                background: lighten($lightgray, 5%);
            }
        }
    }
</style>